package no.skarasoftwaredevelopment.schooltracker.gui;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.gui.adapters.AchievementAdapter;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;
import android.widget.TextView;

public class AchievementsFragment extends Fragment {

	public static final String TAG = "AchievementsFragment";
	
	private MainActivity activity;
	private AchievementAdapter adapter;
	
    public AchievementsFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_achievements, container, false);

        activity = (MainActivity) getActivity();
        
		ListView list = (ListView) rootView.findViewById(R.id.fragment_achievements_listListView);
		
		// TODO: should we do the database connections in an async task?
		DbHelper db = new DbHelper(activity);
		adapter = new AchievementAdapter(activity, db.getStudentAchievements(1)); // TODO: dynamically find studentId
		list.setAdapter(adapter);
		
		// makes android call onCreateOptionsMenu for this fragment which in
		// turn displays how many achievement points the student currently has
		setHasOptionsMenu(true);
		
		// show explanation if the list is empty (no achievements unlocked)
		// we need to do it this way instead of using the built in functions
		// in the ListFragment due to the menu drawer (overrides the listener)
		if (list.getAdapter().getCount() == 0) {
			TextView empty = (TextView) rootView.findViewById(R.id.fragment_achievements_emptyTextView);
			empty.setVisibility(TextView.VISIBLE);
		}
		
        return rootView;
    }
    
    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
    	inflater.inflate(R.menu.main, menu);
       
		TextView points = new TextView(getActivity());
		points.setText(String.valueOf(adapter.getAchievementPoints() + " poeng"));
		points.setTextColor(getResources().getColor(android.R.color.white));
		points.setTextSize(18);
		points.setPaddingRelative(0, 0, 5, 0); // 5 pixels to the right of the textview
		menu.add(1, View.NO_ID, 1, "").setActionView(points).setShowAsAction(MenuItem.SHOW_AS_ACTION_ALWAYS);
    }
    
    @Override
    public void onResume() {
    	super.onResume();
	    activity.setDrawerIndicatorEnabled(true);
    }

}