package no.skarasoftwaredevelopment.schooltracker.gui;

import no.skarasoftwaredevelopment.schooltracker.R;
import android.app.Activity;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTabHost;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

public class CoursesFragment extends Fragment {
    
	public static final String TAG = "CoursesFragment";
	
    private static final String TAB_ADD_COURSE = "no.skarasoftwaredevelopment.schooltracker.gui.ADD_COURSE";
    private static final String TAB_MY_COURSES = "no.skarasoftwaredevelopment.schooltracker.gui.MY_COURSES";
    
    public CoursesFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
    	Activity activity = getActivity();
    	
    	FragmentTabHost tabHost = new FragmentTabHost(activity);
    	tabHost.setup(activity, getChildFragmentManager(), R.id.tabcontent);
    	
        Resources res = activity.getResources();
        tabHost.addTab(
        		tabHost.newTabSpec(TAB_ADD_COURSE).setIndicator(res.getString(R.string.CoursesFragment_tab_add_courses)),
                AddCourseFragment.class, null);
        tabHost.addTab(
        		tabHost.newTabSpec(TAB_MY_COURSES).setIndicator(res.getString(R.string.CoursesFragment_tab_my_courses)),
        		MyCoursesFragment.class, null);
        
        return tabHost;
    }

}