package no.skarasoftwaredevelopment.schooltracker.gui;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.handlers.FormatHandler;
import no.skarasoftwaredevelopment.schooltracker.pojo.AttendanceStats;
import no.skarasoftwaredevelopment.schooltracker.pojo.Course;
import no.skarasoftwaredevelopment.schooltracker.pojo.StudentCourseEffort;
import no.skarasoftwaredevelopment.schooltracker.pojo.activities.ActivityType;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ScrollView;
import android.widget.TextView;

public class EffortCourseFragment extends Fragment {
	
	public static final String TAG = "EffortCourseFragment";

	private MainActivity activity;
	private Course course;
	
	private ScrollView statContainer;
	private ProgressTextView remaining;
	private TextView attendedText;
	private ProgressTextView attended;
	private ImageView condition;
	private TextView bubbleStat;
	private ProgressTextView lectures;
	private ProgressTextView lecturesFullText;
	private TextView exercisesText;
	private ProgressTextView exercises;

    public EffortCourseFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_effort_course, container, false);        
        
        activity = (MainActivity) getActivity();
	    activity.setDrawerIndicatorEnabled(false);
	    
	    statContainer = (ScrollView) rootView.findViewById(R.id.fragment_effort_course_containerScrollView);
	    remaining = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_remainingProgressTextView);
	    attendedText = (TextView) rootView.findViewById(R.id.fragment_effort_attendedTextView);
	    attended = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_attendedProgressTextView);
	    condition = (ImageView) rootView.findViewById(R.id.fragment_effort_condition);
        bubbleStat = (TextView) rootView.findViewById(R.id.effort_condition_percent);
	    lectures = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_lecturesProgressTextView);
	    lecturesFullText = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_lecturesFullProgressTextView);
	    exercisesText = (TextView) rootView.findViewById(R.id.fragment_effort_exercisesTextView);
        exercises = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_exercisesProgressTextView);
        
        course = (Course) getArguments().getSerializable(EffortSeparatelyFragment.ARGS_COURSE);
        TextView courseName = (TextView) rootView.findViewById(R.id.fragment_effort_courseTextView);
        courseName.setText(course.getName());
        
        // we need to do this in order to keep the name if the user
        // opens a notification and then hits the back button
        activity.setTitle(activity.getResources().getString(R.string.EffortCourseFragment_actionbar_effort));
        
        // let's crunch some numbers!
        new CrunchTask().execute();

//	    BarChart chart = (BarChart) rootView.findViewById(R.id.chart);
//	    Random r = new Random();
//	    
//	    ArrayList<BarDataSet> dataSets = new ArrayList<BarDataSet>();
    	
    	
//	    for (int i = 0; i < 10; i++) {
//	    	ArrayList<BarEntry> valsComp1 = new ArrayList<BarEntry>();
//	    	BarDataSet setComp1 = new BarDataSet(valsComp1, String.valueOf(i+1));
//	    	setComp1.addEntry(new BarEntry(r.nextFloat() * 100, i));
//	    	valsComp1.add(new BarEntry(r.nextFloat() * 100, i));
//	    	dataSets.add(setComp1);	    	
//	    	
//	    	//xVals.add(String.valueOf(r.nextInt(100)+1));
//	    }
	    
//	    ArrayList<BarEntry> valsComp1 = new ArrayList<BarEntry>();
//	    for (int i = 0; i < 30; i++) {
//	    	valsComp1.add(new BarEntry(r.nextFloat() * 100, i));
//	    }
//	    
//	    BarDataSet set = new BarDataSet(valsComp1, "hurr");
//	    
//	    ArrayList<String> xVals = new ArrayList<String>();
//	    for (int i = 0; i < 30; i++) {
//	    	xVals.add(String.valueOf(i+1));
//	    }
//	    
//	    BarData data = new BarData(xVals, set);
//	    chart.setData(data);
//	    chart.setDrawLegend(false);
//	    //chart.setDrawYLabels(false);	    
//	    chart.setDescription("");
//	    	   
//	    XLabels xl = chart.getXLabels();
//	    xl.setPosition(XLabelPosition.BOTTOM);

        // TODO: not used as of now, real time updates of the GUI aren't really necessary, are they?
//        IntentFilter mStatusIntentFilter = new IntentFilter(PositionTask.BROADCAST_ACTION);
//        DownloadStateReceiver mDownloadStateReceiver = new DownloadStateReceiver();
//        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(mDownloadStateReceiver, mStatusIntentFilter);

        return rootView;
    }
    
    @Override
    public void onStop() {
    	super.onStop();
    	
    	// we need to do this in case the user swipes left to show the menu drawer
    	// doing so will use the correct action bar indicator for the menu
    	activity.setDrawerIndicatorEnabled(true);
    }
    
    @Override
    public void onResume() {
    	super.onResume();
    	
    	// due to the life cycle of fragments, onStop will get called whenever the
    	// app is running in the background, meaning that we have to disable the
    	// drawer indicator in the action bar again when this fragment gets recreated
    	activity.setDrawerIndicatorEnabled(false);
    }
    
    private class CrunchTask extends AsyncTask<String, String, String> {
    	
    	private static final String TAG = "CrunchTask";
    	
    	private AlertDialog dialog;
    	private int activitiesTotal;
    	private int activitiesPassed;
    	private double activitiesPassedPercent;
    	private int activitiesAttended;
    	private double activitiesAttendedPercent;
    	private int lecturesPassed;
    	private int lecturesAttended;
    	private double lecturesAttendedPercent;
    	private int lecturesFull;
    	private double lecturesFullPercent;
    	private int exercisesPassed;
    	private int exercisesAttended;
    	private double exercisesAttendedPercent;
    	
    	@SuppressLint("InflateParams")
		@Override
		protected void onPreExecute() {
			// show loader dialog
			View v = activity.getLayoutInflater().inflate(R.layout.dialog_loader, null);
			dialog = new AlertDialog.Builder(activity)
					.setView(v)
					.setCancelable(false)
					.setTitle("Krnsjer data..").create();
			dialog.show();
		}
		
		@Override
		protected String doInBackground(String... input) {
	        DbHelper db = new DbHelper(activity);
	        StudentCourseEffort effort = db.getStudentCourseEffort(1, course.getCode()); // TODO: get studentId dynamically
	        
	        if (effort == null || !effort.isUpToDate()) {
	        	Log.e(TAG, "refreshing data..");
	        	
	            // activities
	            AttendanceStats attendanceInfo = db.getAttendanceStatsDetailed(1, course); // TODO: get studentId dynamically
	            activitiesTotal = attendanceInfo.getTotal();
	            activitiesPassed = attendanceInfo.getAttended();
	            activitiesPassedPercent = attendanceInfo.getPercent();
	            
	            // activities, participated
	            attendanceInfo = db.getAttendanceStats(1, course); // TODO: get studentId dynamically
	    		activitiesAttended = attendanceInfo.getAttended();
	    		activitiesAttendedPercent = attendanceInfo.getPercent();
	    		
	    		// lectures
	    		attendanceInfo = db.getAttendanceStatsType(1, course, ActivityType.LECTURE); // TODO: get studentId dynamically
	    		lecturesPassed = attendanceInfo.getTotal();
	    		lecturesAttended = attendanceInfo.getAttended();
	    		lecturesAttendedPercent = attendanceInfo.getPercent();
	            
	            // lectures, 100%
	            attendanceInfo = db.getAttendanceStatsFull(1, course, ActivityType.LECTURE); // TODO: get studentId dynamically	            
	            lecturesFull = attendanceInfo.getAttended();
	            lecturesFullPercent = attendanceInfo.getPercent();
	            
	            // exercises
	            attendanceInfo = db.getAttendanceStatsType(1, course, ActivityType.EXERCISE); // TODO: get studentId dynamically
            	exercisesPassed = attendanceInfo.getTotal();
            	exercisesAttended = attendanceInfo.getAttended();
            	exercisesAttendedPercent = attendanceInfo.getPercent();
		        
		        // cache the data calculated above so we don't have to do it
		        // again next time the student accesses this course
		        // unless the data have gone stale and aren't up-to-date anymore
	            StudentCourseEffort newEffort = new StudentCourseEffort(
		        		1, course.getCode(), activitiesTotal, activitiesPassed, // TODO: get studentId dynamically
		        		activitiesAttended, lecturesPassed, lecturesAttended,
		        		lecturesFull, exercisesPassed, exercisesAttended, true);

	            if (effort != null) {
	            	db.updateStudentCourseEffort(effort);
	            } else {
	            	db.addStudentCourseEffort(newEffort);
	            }
	        } else {
	        	Log.e(TAG, "using existing data..");
	        	
	        	effort = db.getStudentCourseEffort(1, course.getCode()); // TODO: get dynamically, also new variable names
	        	
	        	activitiesTotal = effort.getActivitiesTotal();
	        	activitiesPassed = effort.getActivitiesPassed();
	        	activitiesPassedPercent = ((double) activitiesPassed / activitiesTotal) * 100;
	        	activitiesAttended = effort.getActivitiesAttended();
	        	activitiesAttendedPercent = ((double) activitiesAttended / activitiesPassed) * 100;
	        	lecturesPassed = effort.getLecturesPassed();
	        	lecturesAttended = effort.getLecturesAtteneded();
	        	lecturesAttendedPercent = ((double) lecturesAttended / lecturesPassed) * 100;
	        	lecturesFull = effort.getLecturesFull();
	        	lecturesFullPercent = ((double) lecturesFull / lecturesAttended) * 100;
	        	exercisesPassed = effort.getExercisesPassed();
	        	exercisesAttended = effort.getExercisesAttended();
	        	exercisesAttendedPercent = ((double) exercisesAttended / exercisesPassed) * 100;
	        }
	        
			return null;
		}
		
		@Override
		protected void onProgressUpdate(String... values) {
		}
	
		@Override
		protected void onPostExecute(String results) {
			// activities remaining
	        String percent = FormatHandler.decimalFormat.format(activitiesPassedPercent);
	        remaining.setMaxValue(activitiesTotal);
	        remaining.setValue(activitiesPassed);
	        remaining.setText(activitiesPassed + " / " + activitiesTotal + " (" + percent + "%)");

	        // activities attended
	        double percentRaw = activitiesAttendedPercent;
			percent = FormatHandler.decimalFormat.format(activitiesAttendedPercent);

			// no reason to show activities attended if there is no exercises
			// as this will display the same information as the lectures
			if (exercisesPassed > 0) {
				attended.setMaxValue(activitiesPassed);
				attended.setValue(activitiesAttended);
				attended.setText(activitiesAttended + " / " + activitiesPassed + " (" + percent + "%)");
			} else {
				attendedText.setVisibility(View.GONE);
				attended.setVisibility(View.GONE);
			}
			
	        // condition		        
	        if (percentRaw >= 0 && percentRaw < 10) {
	        	condition.setImageResource(R.drawable.smiley_0_9);
	        } else if (percentRaw >= 10 && percentRaw < 20) {
	        	condition.setImageResource(R.drawable.smiley_10_19);
	        } else if (percentRaw >= 20 && percentRaw < 30) {
	        	condition.setImageResource(R.drawable.smiley_20_29);
	        } else if (percentRaw >= 30 && percentRaw < 40) {
	        	condition.setImageResource(R.drawable.smiley_30_39);
	        } else if (percentRaw >= 40 && percentRaw < 50) {
	        	condition.setImageResource(R.drawable.smiley_40_49);
	        } else if (percentRaw >= 50 && percentRaw < 60) {
	        	condition.setImageResource(R.drawable.smiley_50_59);
	        } else if (percentRaw >= 60 && percentRaw < 70) {
	        	condition.setImageResource(R.drawable.smiley_60_69);
	        } else if (percentRaw >= 70 && percentRaw < 80) {
	        	condition.setImageResource(R.drawable.smiley_70_79);
	        } else if (percentRaw >= 80 && percentRaw < 90) {
	        	condition.setImageResource(R.drawable.smiley_80_89);
	        } else if (percentRaw >= 90 && percentRaw <= 100) {
	        	condition.setImageResource(R.drawable.smiley_90_100);
	        }
	        bubbleStat.setText(percent + "%");

			// lectures
			percent = FormatHandler.decimalFormat.format(lecturesAttendedPercent);
	        lectures.setMaxValue(lecturesPassed);
	        lectures.setValue(lecturesAttended);
	        lectures.setText(lecturesAttended + " / " + lecturesPassed + " (" + percent + "%)");
	        
	        // lectures that have 100% attendance (not 75% of the positions inside)
	        percent = FormatHandler.decimalFormat.format(lecturesFullPercent);
	        lecturesFullText.setMaxValue(lecturesAttended);
	        lecturesFullText.setValue(lecturesFull);
	        lecturesFullText.setText(lecturesFull + " / " + lecturesAttended + " (" + percent + "%)");
	        
	        // exercises
	        if (exercisesPassed > 0) {
	        	percent = FormatHandler.decimalFormat.format(exercisesAttendedPercent);
	        	exercises.setMaxValue(exercisesPassed);
	        	exercises.setValue(exercisesAttended);
	        	exercises.setText(exercisesAttended + " / " + exercisesPassed + " (" + percent + "%)");
	        } else {
		    	exercisesText.setVisibility(View.INVISIBLE);
		    	exercises.setVisibility(View.INVISIBLE);
		    }
	        
	        // hide the loader and display the results
	        statContainer.setVisibility(View.VISIBLE);
	        dialog.cancel();
		}

    }

}