package no.skarasoftwaredevelopment.schooltracker.gui;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.gui.adapters.CourseAdapter;
import no.skarasoftwaredevelopment.schooltracker.pojo.Course;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

public class EffortSeparatelyFragment extends Fragment {

	public static final String TAG = "EffortSeparatelyFragment";
	public static final String ARGS_COURSE = "no.skarasoftwaredevelopment.schooltracker.gui.COURSE";
	
	private MainActivity activity;
	
    public EffortSeparatelyFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_effort_separately, container, false);

        activity = (MainActivity) getActivity();
        
		final ListView list = (ListView) rootView.findViewById(R.id.fragment_effort_separately_listListView);
		list.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> l, View v, int position, long id) {
				// TODO: better solution <3
				Bundle args = new Bundle();
				Course c = (Course) list.getAdapter().getItem(position);
				args.putSerializable(ARGS_COURSE, c);
				
				Fragment fragment = new EffortCourseFragment();
				fragment.setArguments(args);
				
			    FragmentManager fragmentManager = activity.getSupportFragmentManager();
			    fragmentManager.beginTransaction()
			    		.replace(R.id.content_frame, fragment)
			    		.addToBackStack(null)
			    		.commit();
			}
		});
		
		// TODO: should we do the database connections in an async task?
		DbHelper db = new DbHelper(getActivity());
		list.setAdapter(new CourseAdapter(activity, db.getStudentCourses(1))); // TODO: dynamically find studentId
        
		// show explanation if the list is empty (no items in the inventory)
		// we need to do it this way instead of using the built in functions
		// in the ListFragment due to the menu drawer (overrides the listener)
		if (list.getAdapter().getCount() == 0) {
			TextView empty = (TextView) rootView.findViewById(R.id.fragment_effort_separately_emptyTextView);
			empty.setVisibility(TextView.VISIBLE);
		}
		
        return rootView;
    }
    
    public void onResume() {
    	super.onResume();
	    activity.setDrawerIndicatorEnabled(true);
    }

}