package no.skarasoftwaredevelopment.schooltracker.gui;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.handlers.FormatHandler;
import no.skarasoftwaredevelopment.schooltracker.pojo.Attendance;
import no.skarasoftwaredevelopment.schooltracker.pojo.AttendanceStats;
import no.skarasoftwaredevelopment.schooltracker.pojo.Student;
import android.app.Activity;
import android.app.AlertDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ScrollView;
import android.widget.TextView;

public class EffortTotalFragment extends Fragment {
	
	public static final String TAG = "EffortFragment";
	
	private Activity activity;
	
	private ScrollView statContainer;
	private ProgressTextView remaining;
	private ProgressTextView attended;
	private ImageView condition;
	private TextView bubbleStat;
	private ProgressTextView highest;
	private ProgressTextView highestStat;
	private ProgressTextView lowest;
	private ProgressTextView lowestStat;
	private TextView missingCourses;

    public EffortTotalFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_effort_total, container, false);
        
        activity = getActivity();
        
        statContainer = (ScrollView) rootView.findViewById(R.id.fragment_effort_total_containerScrollView);
        remaining = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_remainingProgressTextView);
        attended = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_attendedProgressTextView);
        condition = (ImageView) rootView.findViewById(R.id.fragment_effort_condition);
        bubbleStat = (TextView) rootView.findViewById(R.id.effort_condition_percent);
        highest = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_highestProgressTextView);
        highestStat = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_highestStatProgressTextView);
        lowest = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_lowestProgressTextView);
        lowestStat = (ProgressTextView) rootView.findViewById(R.id.fragment_effort_lowestStatProgressTextView);
        missingCourses = (TextView) rootView.findViewById(R.id.fragment_effort_missingCoursesTextView);

        // let's crunch some numbers!
        new CrunchTask().execute();
        
        // TODO: not in use as of now
//        IntentFilter mStatusIntentFilter = new IntentFilter(PositionTask.BROADCAST_ACTION);
//        DownloadStateReceiver mDownloadStateReceiver = new DownloadStateReceiver();
//        LocalBroadcastManager.getInstance(activity).registerReceiver(mDownloadStateReceiver, mStatusIntentFilter);
        
        // start tracking timer
        //((MainActivity) activity).runTimer();
		//status.setText("Task kjrer...");
		//status.setTextColor(customGreen);
		
		// TODO: remove this, just here for testing purposes
		//Attendance attendance = new Attendance(1, Calendar.getInstance(), Calendar.getInstance(), 10, false, false);
		//Timer timer = new Timer();
    	//PositionTask timerTask = new PositionTask(activity, 1, "TDT4195", 0, attendance); // FIXME: dynamic plx
    	//timer.schedule(timerTask, 0, 1000);		
		
//		List<Integer> attendanceIds = PositionService.getTrackers();
//		for (int id : attendanceIds) {
//			Log.e(TAG, "attendance id: " + id);
//		}
		
//		Attendance a = new Attendance(186);
//		PositionTask task = new PositionTask(activity, 1, a);
//		boolean status = PositionService.addTask(task);
//		if (status) {
//			Log.e(TAG, "tasken ble lagt til..");
//		} else {
//			Log.e(TAG, "tasken ble ikke lagt til..");
//		}
		
        return rootView;
    }
    
//  // Broadcast receiver for receiving status updates from the IntentService
//  private class DownloadStateReceiver extends BroadcastReceiver {
//
//      // Prevents instantiation
//      private DownloadStateReceiver() {
//      }
//
//      // Called when the BroadcastReceiver gets an Intent it's registered to receive
//      public void onReceive(Context context, Intent intent) {     	
//      	PositionData pos = (PositionData) intent.getSerializableExtra(PositionTask.EXTENDED_POSITION);
//      }
//
//  }
    
    private class CrunchTask extends AsyncTask<String, String, String> {
    	
    	private static final String TAG = "CrunchTask";
    	
    	private AlertDialog dialog;
    	private int total;
    	private int activitiesPassed;
    	private int activitiesAttended;
    	private AttendanceStats highestCourse;
    	private AttendanceStats lowestCourse;
    	
		@Override
		protected void onPreExecute() {
			// show loader dialog
			View v = activity.getLayoutInflater().inflate(R.layout.dialog_loader, null);
			dialog = new AlertDialog.Builder(activity)
					.setView(v)
					.setCancelable(false)
					.setTitle("Krnsjer data..").create();
			dialog.show();
		}
		
		@Override
		protected String doInBackground(String... input) {
	        DbHelper db = new DbHelper(activity);
	        
	        if (!db.isStudentEffortUpToDate(1)) { // TODO: get studentId dynamically
	        	Log.e(TAG, "refreshing data..");
	        	
		        // activities remaining
		        total = db.getTotalAttendances(1); // TODO: get studentId dynamically
		        List<Attendance> attendances = db.getAttendedTotal(1); // TODO: get studentId dynamically
		        activitiesPassed = attendances.size();
		        activitiesAttended = 0;
		        
		        for (Attendance a : attendances) {
		        	if (a.hasAttended()) {
		        		activitiesAttended++;
		        	}
		        }
		        
		        // highest attendance stat
		        highestCourse = db.getHighestAttendanceStats(1); // TODO: get dynamically, also new variable names
		        
		        // lowest attendance stat
		        lowestCourse = db.getLowestAttendanceStats(1); // TODO: get dynamically, also new variable names
		        
		        // cache the data calculated above so we don't have to do it
		        // again next time the student accesses this fragment
		        // unless the data have gone stale and aren't up-to-date anymore
		        Student s = new Student(1, total, activitiesPassed, activitiesAttended, highestCourse, lowestCourse, true); // TODO: get studentId dynamically
		        db.updateStudentEfforts(s);
	        } else {
	        	Log.e(TAG, "using existing data..");
	        	
	        	Student s = db.getStudentEfforts(1); // TODO: get dynamically, also new variable names
	        	
	        	total = s.getActivitiesTotal();
	        	activitiesPassed = s.getActivitiesPassed();
	        	activitiesAttended = s.getActivitiesAttended();
	        	highestCourse = s.getHighestStat();
	        	lowestCourse = s.getLowestStat();
	        }
	        
			return null;
		}
		
		@Override
		protected void onProgressUpdate(String... values) {
		}
	
		@Override
		protected void onPostExecute(String results) {
			if (total > 0) {
		        // activities remaining
		        remaining.setMaxValue(total);
		        remaining.setValue(activitiesPassed);
		        String percent = FormatHandler.decimalFormat.format((double) remaining.getValue() / 100);
		        remaining.setText(activitiesPassed + " / " + total + " (" + percent + "%)");
		        
		        // activities attended
		        double percentRaw = ((double) activitiesAttended / activitiesPassed) * 100;
		        percent = FormatHandler.decimalFormat.format(percentRaw);
		        
		        attended.setMaxValue(activitiesPassed);
		        attended.setValue(activitiesAttended);
		        attended.setText(activitiesAttended + " / " + activitiesPassed + " (" + percent + "%)");
		        
		        // condition	        
		        if (percentRaw >= 0 && percentRaw < 10) {
		        	condition.setImageResource(R.drawable.smiley_0_9);
		        } else if (percentRaw >= 10 && percentRaw < 20) {
		        	condition.setImageResource(R.drawable.smiley_10_19);
		        } else if (percentRaw >= 20 && percentRaw < 30) {
		        	condition.setImageResource(R.drawable.smiley_20_29);
		        } else if (percentRaw >= 30 && percentRaw < 40) {
		        	condition.setImageResource(R.drawable.smiley_30_39);
		        } else if (percentRaw >= 40 && percentRaw < 50) {
		        	condition.setImageResource(R.drawable.smiley_40_49);
		        } else if (percentRaw >= 50 && percentRaw < 60) {
		        	condition.setImageResource(R.drawable.smiley_50_59);
		        } else if (percentRaw >= 60 && percentRaw < 70) {
		        	condition.setImageResource(R.drawable.smiley_60_69);
		        } else if (percentRaw >= 70 && percentRaw < 80) {
		        	condition.setImageResource(R.drawable.smiley_70_79);
		        } else if (percentRaw >= 80 && percentRaw < 90) {
		        	condition.setImageResource(R.drawable.smiley_80_89);
		        } else if (percentRaw >= 90 && percentRaw <= 100) {
		        	condition.setImageResource(R.drawable.smiley_90_100);
		        }
		        
		        bubbleStat.setText(percent + "%");
		        
		        // highest course attendance
		        percent = FormatHandler.decimalFormat.format(highestCourse.getPercent());
	
		        highest.setMaxValue(highestCourse.getTotal());
		        highest.setValue(highestCourse.getAttended());
		        highest.setText(highestCourse.getCourse().getName());
	
		        highestStat.setMaxValue(highestCourse.getTotal());
		        highestStat.setValue(highestCourse.getAttended());
		        highestStat.setText(highestCourse.getAttended() + " / " + highestCourse.getTotal() + " (" + percent + "%)");
	
		        // lowest course attendance
		        percent = FormatHandler.decimalFormat.format(lowestCourse.getPercent());
		        
		        lowest.setMaxValue(lowestCourse.getTotal());
		        lowest.setValue(lowestCourse.getAttended());
		        lowest.setText(lowestCourse.getCourse().getName());
	
		        lowestStat.setMaxValue(lowestCourse.getTotal());
		        lowestStat.setValue(lowestCourse.getAttended());
		        lowestStat.setText(lowestCourse.getAttended() + " / " + lowestCourse.getTotal() + " (" + percent + "%)");
		        
		        statContainer.setVisibility(View.VISIBLE);
			} else {
				missingCourses.setVisibility(View.VISIBLE);
			}
	        
	        // hide the loader and display the results
	        dialog.cancel();
		}

    }

}