package no.skarasoftwaredevelopment.schooltracker.gui;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.gui.adapters.ItemAdapter;
import no.skarasoftwaredevelopment.schooltracker.pojo.Chest;
import no.skarasoftwaredevelopment.schooltracker.pojo.Item;
import no.skarasoftwaredevelopment.schooltracker.pojo.Item.ItemType;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

public class InventoryFragment extends Fragment {

	public static final String TAG = "InventoryFragment";
	public static final String ARGS_ITEM = "o.skarasoftwaredevelopment.schooltracker.gui.ITEM";
	
	private MainActivity activity;
	
    public InventoryFragment() {
        // Empty constructor required for fragment subclasses
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_inventory, container, false);

        activity = (MainActivity) getActivity();
        
		final ListView list = (ListView) rootView.findViewById(R.id.fragment_inventory_listListView);
		list.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> l, View v, int position, long id) {
				// TODO: start different fragments based on what item it is
				Item i = (Item) list.getAdapter().getItem(position);
				if (i instanceof Chest) {
					Chest c = (Chest) i;
					
					if (!c.isUsed()) {
						Bundle args = new Bundle();
						args.putSerializable(ARGS_ITEM, i);
						
						Fragment fragment = new ChestFragment();
						fragment.setArguments(args);
						
					    FragmentManager fragmentManager = activity.getSupportFragmentManager();
					    fragmentManager.beginTransaction()
					    		.replace(R.id.content_frame, fragment)
					    		.addToBackStack(null)
					    		.commit();
					}
				}
			}
		});
		
		// TODO: should we do the database connections in an async task? yes!
		DbHelper db = new DbHelper(activity);
		
        // TODO: remove me, I'm just here for testing purposes
//		Item loot = LootHandler.generateLoot();
//		if (loot != null) {
//			db.addLoot(1, loot); // TODO: should get studentId dynamically
//		}
		
		list.setAdapter(new ItemAdapter(activity, db.getLoot(1, ItemType.CHEST))); // TODO: dynamically find studentId
		
		// show explanation if the list is empty (no items in the inventory)
		// we need to do it this way instead of using the built in functions
		// in the ListFragment due to the menu drawer (overrides the listener)
		if (list.getAdapter().getCount() == 0) {
			TextView empty = (TextView) rootView.findViewById(R.id.fragment_inventory_emptyTextView);
			empty.setVisibility(TextView.VISIBLE);
		}
		
        return rootView;
    }
    
    public void onResume() {
    	super.onResume();
	    activity.setDrawerIndicatorEnabled(true);
    }

}