package no.skarasoftwaredevelopment.schooltracker.gui;

import android.content.Context;
import android.graphics.drawable.ClipDrawable;
import android.graphics.drawable.LayerDrawable;
import android.util.AttributeSet;
import android.widget.TextView;

public class ProgressTextView extends TextView {

	private int mMaxValue = 100;
	private int mValue = 0;

	public ProgressTextView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
	}

	public ProgressTextView(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	public ProgressTextView(Context context) {
		super(context);
	}
	
	public void setMaxValue(int maxValue){
		mMaxValue = maxValue;
	}
	
	public int getValue() {
		return mValue;
	}
	
	public synchronized void setValue(int value) {
		this.setText(String.valueOf(value));
		
		LayerDrawable background = (LayerDrawable) this.getBackground();
		
		ClipDrawable barValue = (ClipDrawable) background.getDrawable(1);
		
		if (value > 0) {
			mValue = (int) (value * 10000 / mMaxValue);
		} else {
			mValue = 0;
		}
		barValue.setLevel(mValue);
		
		drawableStateChanged();
	}

}