package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.handlers.FormatHandler;
import no.skarasoftwaredevelopment.schooltracker.pojo.Achievement;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class AchievementAdapter extends ArrayAdapter<Achievement> {

	public static final String TAG = "AchievementAdapter";
	
	private Activity activity;
	private List<Achievement> achievements;
	
	public AchievementAdapter(Activity activity, List<Achievement> achievements) {
		super(activity, 0, achievements);
		this.activity = activity;
		this.achievements = achievements;
	}
	
	public int getAchievementPoints() {
		int achievementPoints = 0;
		
		for (Achievement a : achievements) {
			achievementPoints += a.getValue();
		}
		
		return achievementPoints;
	}
	
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {	
		// If we weren't given a view, inflate one
		if (convertView == null) {
			convertView = activity.getLayoutInflater().inflate(R.layout.list_item_achievement, parent, false);
		}
		
		// Configure the view for this Achievement
		Achievement achievement = getItem(position);
		
		TextView name = (TextView) convertView.findViewById(R.id.list_item_achievement_nameTextView);
		name.setText(achievement.getName());
		
		TextView description = (TextView) convertView.findViewById(R.id.list_item_achievement_descriptionTextView);
		description.setText(achievement.getDescription());
		
		TextView value = (TextView) convertView.findViewById(R.id.list_item_achievement_valueTextView);
		value.setText(achievement.getValue() + " poeng");
		
		TextView timestamp = (TextView) convertView.findViewById(R.id.list_item_achievement_timestampTextView);
		timestamp.setText("Oppndd " + FormatHandler.achievementFormat.format(achievement.getTimestamp()));
		
		return convertView;
	}

}