package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.pojo.Chest;
import no.skarasoftwaredevelopment.schooltracker.pojo.Item;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class ItemAdapter extends ArrayAdapter<Item> {

	public static final String TAG = "ItemAdapter";
	
	private Activity activity;
	
	public ItemAdapter(Activity activity, List<Item> items) {
		super(activity, 0, items);
		this.activity = activity;
	}
	
	public void updateData(List<Item> items) {
		clear();
		addAll(items);
	}
	
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {		
		// Configure the view for this Item
		Item item = getItem(position);
		
		if (item instanceof Chest) {
			convertView = activity.getLayoutInflater().inflate(R.layout.list_item_chest, parent, false);
			
			TextView name = (TextView) convertView.findViewById(R.id.list_item_chest_nameTextView);
			name.setText(item.getName());
		} // other kinds of items goes here
		
		return convertView;
	}

}