package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.pojo.Course;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class MyCourseAdapter extends ArrayAdapter<Course> {

	public static final String TAG = "CourseAdapter";
	
	private Activity mActivity;
	
	public MyCourseAdapter(Activity activity, List<Course> courses) {
		super(activity, 0, courses);
		mActivity = activity;
	}
	
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		// If we weren't given a view, inflate one
		if (convertView == null) {
			convertView = mActivity.getLayoutInflater().inflate(R.layout.list_item_course, null);
		}
		
		// Configure the view for this Course
		final Course course = getItem(position);
		
		TextView code = (TextView) convertView.findViewById(R.id.list_item_course_codeTextView);
		code.setText(course.getCode());

		TextView name = (TextView) convertView.findViewById(R.id.list_item_course_nameTextView);
		name.setText(course.getName());
				
		return convertView;
	}

}