package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.Locale;

import no.skarasoftwaredevelopment.schooltracker.R;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class NavigationDrawerAdapter extends ArrayAdapter<String> {

	private final Activity activity;
	private final String[] values;

	public NavigationDrawerAdapter(Activity activity, String[] values) {
		super(activity, R.layout.drawer_list_item, values);
		this.activity = activity;
		this.values = values;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		// If we weren't given a view, inflate one
		if (convertView == null) {
			convertView = activity.getLayoutInflater().inflate(R.layout.drawer_list_item, parent, false);
		}
		
		TextView title = (TextView) convertView.findViewById(R.id.drawer_list_item_titleTextView);
		title.setText(values[position]);
		
		ImageView icon = (ImageView) convertView.findViewById(R.id.drawer_list_item_iconImageView);
		int iconId = activity.getResources().getIdentifier(
				values[position].toLowerCase(Locale.getDefault()),
				"drawable", activity.getPackageName());
		icon.setImageResource(iconId);

		return convertView;
	}

}