package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.pojo.ShopItem;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class ShopAdapter extends ArrayAdapter<ShopItem> {

	public static final String TAG = "ShopAdapter";
	
	private Activity activity;
	private int coins;
	
	public ShopAdapter(Activity activity, List<ShopItem> items, int coins) {
		super(activity, 0, items);
		this.activity = activity;
		this.coins = coins;
	}
	
	public void setCoins(int coins) {
		this.coins = coins;
		notifyDataSetChanged();
	}
	
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		// If we weren't given a view, inflate one
		if (convertView == null) {
			convertView = activity.getLayoutInflater().inflate(R.layout.list_item_shop, null);
		}

		// Configure the view for this Shop Item
		ShopItem item = getItem(position);
		
		if (item.getPrice() > coins) {
			convertView.setBackgroundColor(activity.getResources().getColor(android.R.color.holo_red_light));
		}

		TextView name = (TextView) convertView.findViewById(R.id.list_item_shop_nameTextView);
		name.setText(item.getName());

		TextView description = (TextView) convertView.findViewById(R.id.list_item_shop_descriptionTextView);
		description.setText(item.getDescription());

		ImageView image = (ImageView) convertView.findViewById(R.id.list_item_shop_itemImageView);		
		image.setImageResource(item.getResourceId());

		TextView price = (TextView) convertView.findViewById(R.id.list_item_shop_priceTextView);
		price.setText(String.valueOf(item.getPrice()));
		
		// TODO: handle requirement (red background?)

		return convertView;
	}

}