package no.skarasoftwaredevelopment.schooltracker.gui.adapters;

import java.util.List;

import no.skarasoftwaredevelopment.schooltracker.R;
import no.skarasoftwaredevelopment.schooltracker.pojo.StudyProgram;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class StudyProgramAdapter extends ArrayAdapter<StudyProgram> {

	public static final String TAG = "StudyProgramAdapter";
	
	private Activity mActivity;
	
	public StudyProgramAdapter(Activity activity, List<StudyProgram> programs) {
		super(activity, 0, programs);
		mActivity = activity;
	}
	
	@Override
    public View getDropDownView(int position, View convertView,ViewGroup parent) {
        return getView(position, convertView, parent);
    }
	
	/**
	 * We re-use the layout from the list used on the pages showing a course list
	 * as the changes are so minuscule (showing the study program code in bold instead
	 * of showing the name of the study program in bold).
	 */
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		// If we weren't given a view, inflate one
		if (convertView == null) {
			convertView = mActivity.getLayoutInflater().inflate(R.layout.list_item_course, null);
		}
		
		// Configure the view for this StudyProgram
		StudyProgram program = getItem(position);
		
		TextView code = (TextView) convertView.findViewById(R.id.list_item_course_nameTextView);
		TextView name = (TextView) convertView.findViewById(R.id.list_item_course_codeTextView);
		
		if (position == 0) {
			code.setVisibility(View.GONE);
			name.setText("Velg studieprogrammet ditt..");
		} else {
			code.setVisibility(View.VISIBLE);
			code.setText(program.getCode());
			name.setText(program.getName());
		}
				
		return convertView;
	}

}