package no.skarasoftwaredevelopment.schooltracker.handlers;

import java.util.Random;

import no.skarasoftwaredevelopment.schooltracker.database.DbHelper;
import no.skarasoftwaredevelopment.schooltracker.pojo.Chest;
import no.skarasoftwaredevelopment.schooltracker.pojo.Item;
import android.content.Context;
import android.util.Log;

public class LootHandler {

	public static final String TAG = "LootHandler";

	/**
	 * Can generate a chest as of now.
	 * @return
	 */
	public static Item generateLoot() {
		Item loot = null;
		
		Random rnd = new Random();
		int chance = rnd.nextInt(100) + 1;
		
		// 100% chance of getting a chest after each activity
		if (chance <= Chest.CHANCE_TARGET) {
			chance = rnd.nextInt(100) + 1;
			
			// 5% chance of not getting anything in the chest
			int value = 0;
			if (chance >= 5) {
				value = (int) (rnd.nextFloat() * 100);
				
			}

			// the random int represents the difficulty
			// (how many taps are required to open the chest)
			loot = new Chest(value, rnd.nextInt(10), false);
			Log.e(TAG, "generated chest..");
		}

		return loot;
	}

	/**
	 * If the student has successfully attended an activity, there
	 * is a chance loot will be generated as a result.
	 * 
	 * @param hasAttended
	 * @param db
	 * @param c
	 */
	public static void checkEligibility(boolean hasAttended, DbHelper db, Context c) {
		if (hasAttended) {
			Item loot = generateLoot();
			if (loot != null) {
				db.addLoot(1, loot); // TODO: should get studentId dynamically
				NotificationHandler.notifyLoot(c);
			}
		}
	}
	
}