package no.skarasoftwaredevelopment.schooltracker.handlers;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import no.skarasoftwaredevelopment.schooltracker.pojo.StudentPosition;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

public class ReportPositionHandler {

	private static final String REPORT_URL = "http://hv-6141.idi.ntnu.no/schooltracker/app_register_position.php";
	private static final String STUDENT_UUID = "student_uuid";
	private static final String COURSE_CODE = "course_code";
	private static final String ATTENDANCE_ID = "attendance_id";
	private static final String LONGITUDE = "longitude";
	private static final String LATITUDE = "latitude";
	private static final String FLOOR = "floor";
	private static final String INSIDE = "inside";
	private static final String PROVIDER = "provider";
	
	public static void report(String uuid, String courseCode, StudentPosition position) {
    	ArrayList<NameValuePair> values = new ArrayList<NameValuePair>();
    	values.add(new BasicNameValuePair(STUDENT_UUID, uuid));
    	values.add(new BasicNameValuePair(COURSE_CODE, courseCode));
    	values.add(new BasicNameValuePair(ATTENDANCE_ID, String.valueOf(position.getAttendanceId())));
    	values.add(new BasicNameValuePair(LONGITUDE, position.getLongitude()));
    	values.add(new BasicNameValuePair(LATITUDE, position.getLatitude()));
    	values.add(new BasicNameValuePair(FLOOR, String.valueOf(position.getFloor())));
    	values.add(new BasicNameValuePair(INSIDE, String.valueOf(position.isInside())));
    	values.add(new BasicNameValuePair(PROVIDER, position.getProvider().toString()));
    	
    	// http post
		try {
			HttpClient httpclient = new DefaultHttpClient();
			HttpPost httppost = new HttpPost(REPORT_URL);
			httppost.setEntity(new UrlEncodedFormEntity(values));
			httpclient.execute(httppost);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}