package no.skarasoftwaredevelopment.schooltracker.handlers;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;

public class UploadDbHandler {
	
	public static final String TAG = "DbBackup";
	public static final String UPLOAD_URL = "http://hv-6141.idi.ntnu.no/schooltracker/upload_database.php";
	public static final String CONTENT_TYPE = "application/x-skoleform-app";

	public static void takeBackup(String pathToDb, String studentUUID) {
		HttpURLConnection con = null;
		DataOutputStream outputStream = null;
		FileInputStream fis = null;
		
    	String lineEnd = "\r\n";
    	String twoHyphens = "--";
    	String boundary =  "*****";
    	
    	int bytesRead, bytesAvailable, bufferSize;
    	byte[] buffer;
    	int maxBufferSize = 1*1024*1024;
		
	    try {	    	
	    	fis = new FileInputStream(new File(pathToDb));
	    	
	    	URL url = new URL(UPLOAD_URL);
	    	con = (HttpURLConnection) url.openConnection();

	    	con.setDoInput(true);
	    	con.setDoOutput(true);
	    	con.setUseCaches(false);
	    	con.setRequestMethod("POST");
    	 
	    	con.setRequestProperty("Connection", "Keep-Alive");
	    	con.setRequestProperty("Content-Type", "multipart/form-data;boundary="+boundary);
    	 
    	    outputStream = new DataOutputStream(con.getOutputStream());
    	    outputStream.writeBytes(twoHyphens + boundary + lineEnd);
    	    
    	    String filename = studentUUID + "_" + System.currentTimeMillis() + ".db";
    	    outputStream.writeBytes("Content-Disposition: form-data; name=\"database\"; filename=\"" + filename + "\"" + lineEnd);
    	    outputStream.writeBytes(lineEnd);
    	 
    	    bytesAvailable = fis.available();
    	    bufferSize = Math.min(bytesAvailable, maxBufferSize);
    	    buffer = new byte[bufferSize];
    	 
    	    // read file
    	    bytesRead = fis.read(buffer, 0, bufferSize);
    	    while (bytesRead > 0) {
    	        outputStream.write(buffer, 0, bufferSize);
    	        bytesAvailable = fis.available();
    	        bufferSize = Math.min(bytesAvailable, maxBufferSize);
    	        bytesRead = fis.read(buffer, 0, bufferSize);
    	    }
    	 
    	    outputStream.writeBytes("Content-Type: " + CONTENT_TYPE + lineEnd);
    	    outputStream.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
    	 
    	    // responses from the server (code and message)
    	    // not currently in use, but might be used later on
    	    con.getResponseCode();
    	    con.getResponseMessage();
    	 
    	    fis.close();
    	    outputStream.flush();
    	    outputStream.close();
	    } catch (FileNotFoundException e) {
	    	e.printStackTrace();
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}