package no.skarasoftwaredevelopment.schooltracker.pojo;

import java.util.Date;

import no.skarasoftwaredevelopment.schooltracker.handlers.AchievementHandler.AchievementType;

public class Achievement {

	private int id;
	private int category;
	private AchievementType type;
	private String name;
	private String description;
	private int value;
	private Date timestamp;
	
	public Achievement(int id, int category, AchievementType type, String name, String description, int value, Date timestamp) {
		this.id = id;
		this.category = category;
		this.type = type;
		this.name = name;
		this.description = description;
		this.value = value;
		this.timestamp = timestamp;
	}
	
	public Achievement(int id, int category, String name, String description, int value) {
		this.id = id;
		this.category = category;
		this.name = name;
		this.description = description;
		this.value = value;		
	}
	
	public Achievement(int category, AchievementType type, String name, String description, int value) {
		this.category = category;
		this.id = type.getId();
		this.name = name;
		this.description = description;
		this.value = value;		
	}

	public int getId() {
		return id;
	}
	
	public int getCategory() {
		return category;
	}
	
	public AchievementType getType() {
		return type;
	}

	public String getName() {
		return name;
	}

	public String getDescription() {
		return description;
	}

	public int getValue() {
		return value;
	}
	
	public Date getTimestamp() {
		return timestamp;
	}

	@Override
	public String toString() {
		return "Achievement [id=" + id + ", type=" + type + ", name=" + name
				+ ", description=" + description + ", value=" + value
				+ ", timestamp=" + timestamp + "]";
	}

}