package no.skarasoftwaredevelopment.schooltracker.pojo;

import no.skarasoftwaredevelopment.schooltracker.R;

public class Chest extends Item {

	public static final String NAME = "Kiste";
	public static final int CHANCE_TARGET = 100;
	public static final int RESOURCE_ID = R.drawable.chest;
	
	private static final long serialVersionUID = 515514708434966874L;

	private int value;
	private int difficulty;
	
	public Chest(int id, int value, int difficulty, boolean used) {
		super(id, ItemType.CHEST, NAME, used);
		this.value = value;
		this.difficulty = difficulty;
	}
	
	public Chest(int value, int difficulty, boolean used) {
		super(ItemType.CHEST, NAME, used);
		this.value = value;
		this.difficulty = difficulty;
	}

	public int getValue() {
		return value;
	}
	
	public int getDifficulty() {
		return difficulty;
	}

	@Override
	public int getChanceTarget() {
		return CHANCE_TARGET;
	}

	@Override
	public int getResourceId() {
		return RESOURCE_ID;
	}
	
}