package no.skarasoftwaredevelopment.schooltracker.pojo;

import java.io.Serializable;

public abstract class Item implements Serializable {

	private static final long serialVersionUID = 7879891605711047279L;

	private int id;
	private ItemType type;
	private String name;
	private boolean used;
	
	public Item(int id, ItemType type, String name, boolean used) {
		this.id = id;
		this.type = type;
		this.name = name;
		this.used = used;
	}
	
	public Item(ItemType type, String name, boolean used) {
		this.type = type;
		this.name = name;
		this.used = used;
	}
	
	public int getId() {
		return id;
	}
	
	public ItemType getType() {
		return type;
	}

	public String getName() {
		return name;
	}
	
	public boolean isUsed() {
		return used;
	}
	
	public void setUsed(boolean used) {
		this.used = used;
	}
	
	public abstract int getChanceTarget();
	
	public abstract int getResourceId();

	public enum ItemType {
		NONE(0),		
		CHEST(1),
		ICE_AXE(2);
		
		private final int id;
		
		private ItemType(int id) {
			this.id = id;
		}
		
		public int getId() {
			return id;
		}
		
		public static ItemType getItemType(int id) {
			switch(id) {
				case 1:
					return CHEST;
				case 2:
					return ICE_AXE;
				default:
					return NONE;
			}
		}
	}
	
}