package no.skarasoftwaredevelopment.schooltracker.pojo;

public class ShopItem extends Item {

	private static final long serialVersionUID = 7492327697468921167L;
	
	private String description;
	private int price;
	private int amount;
	private int requirement;
	
	public ShopItem(ItemType type, String name, String description, int price, int amount, int requirement) {
		super(type, name, false); // a shop item is never used, so we default it to false
		this.description = description;
		this.price = price;
		this.amount = amount;
		this.requirement = requirement;
	}

	public String getDescription() {
		return description;
	}

	public int getPrice() {
		return price;
	}
	
	public int getAmount() {
		return amount;
	}

	public int getRequirement() {
		return requirement;
	}

	@Override
	public int getResourceId() {
		// TODO: this sucks, find a more elegant way of doing this
		switch (getType()) {
			case ICE_AXE:
				return IceAxe.RESOURCE_ID;
			default:
				return 0;
		}
	}

	@Override
	public int getChanceTarget() {
		// TODO Auto-generated method stub
		return 0;
	}

}