package no.skarasoftwaredevelopment.schooltracker.pojo;

import java.io.Serializable;
import java.util.Date;

public class Student implements Serializable {

	private static final long serialVersionUID = -7294902315841259824L;

	private int id;
	private String username;
	private String email;
	private int coins;
	private int taps;
	private String studyProgram;
	private String uuid;
	private int coinTotal;
	private Date timestamp;

	// used in EffortTotalFragment
	private int activitiesTotal;
	private int activitiesPassed;
	private int activitiesAttended;
	private AttendanceStats highestStat;
	private AttendanceStats lowestStat;
	private boolean upToDate;

	public Student(int id, String username, String email, int coins, int taps, String studyProgram, String uuid, int coinTotal, Date timestamp) {
		this.id = id;
		this.username = username;
		this.email = email;
		this.coins = coins;
		this.taps = taps;
		this.studyProgram = studyProgram;
		this.uuid = uuid;
		this.coinTotal = coinTotal;
		this.timestamp = timestamp;
	}
	
	public Student(int id, int activitiesTotal, int activitiesPassed, int activitiesAttended, AttendanceStats highestStats, AttendanceStats lowestStat, boolean upToDate) {
		this.id = id;
		this.activitiesTotal = activitiesTotal;
		this.activitiesPassed = activitiesPassed;
		this.activitiesAttended = activitiesAttended;
		this.highestStat = highestStats;
		this.lowestStat = lowestStat;
		this.upToDate = upToDate;
	}

	public int getId() {
		return id;
	}
	
	public String getUsername() {
		return username;
	}

	public String getEmail() {
		return email;
	}
	
	public int getCoins() {
		return coins;
	}
	
	public int getTaps() {
		return taps;
	}
	
	public String getStudyProgram() {
		return studyProgram;
	}
	
	public String getUUID() {
		return uuid;
	}
	
	public int getCoinTotal() {
		return coinTotal;
	}
	
	public Date getTimestamp() {
		return timestamp;
	}

	public int getActivitiesTotal() {
		return activitiesTotal;
	}

	public int getActivitiesPassed() {
		return activitiesPassed;
	}

	public int getActivitiesAttended() {
		return activitiesAttended;
	}

	public AttendanceStats getHighestStat() {
		return highestStat;
	}
	
	public AttendanceStats getLowestStat() {
		return lowestStat;
	}
	
	public boolean isUpToDate() {
		return upToDate;
	}

}