package no.skarasoftwaredevelopment.schooltracker.pojo;

import no.skarasoftwaredevelopment.schooltracker.pojo.PositionData.PositionProvider;

public class StudentPosition {

	private int id;
	private int studentId;
	private int attendanceId;
	private String timestamp;
	private String longitude;
	private String latitude;
	private double floor;
	private boolean inside;
	private PositionProvider provider;
	
	/**
	 * This constructor is used when retrieving a record from the database.
	 * @param id
	 * @param studentId
	 * @param attendanceId
	 * @param timestamp
	 * @param longitude
	 * @param latitude
	 * @param floor
	 * @param inside
	 */
	public StudentPosition(int id, int studentId, int attendanceId, String timestamp, String longitude, String latitude, double floor, boolean inside) {
		this.id = id;
		this.studentId = studentId;
		this.attendanceId = attendanceId;
		this.timestamp = timestamp;
		this.longitude = longitude;
		this.latitude = latitude;
		this.floor = floor;
		this.inside = inside;
	}
	
	/**
	 * This constructor is used when adding a new position to the database.
	 * 
	 * @param studentId
	 * @param attendanceId
	 * @param longitude
	 * @param latitude
	 * @param floor
	 * @param inside
	 * @param provider
	 */
	public StudentPosition(int studentId, int attendanceId, String longitude, String latitude, double floor, boolean inside, PositionProvider provider) {
		this.studentId = studentId;
		this.attendanceId = attendanceId;
		this.longitude = longitude;
		this.latitude = latitude;
		this.floor = floor;
		this.inside = inside;
		this.provider = provider;
	}

	public int getId() {
		return id;
	}

	public int getStudentId() {
		return studentId;
	}

	public int getAttendanceId() {
		return attendanceId;
	}

	public String getTimestamp() {
		return timestamp;
	}

	public String getLongitude() {
		return longitude;
	}
	
	public String getLatitude() {
		return latitude;
	}
	
	public double getFloor() {
		return floor;
	}
	
	public boolean isInside() {
		return inside;
	}
	
	public PositionProvider getProvider() {
		return provider;
	}

	@Override
	public String toString() {
		return "StudentPosition [id=" + id + ", studentId=" + studentId
				+ ", attendanceId=" + attendanceId + ", timestamp=" + timestamp
				+ ", longitude=" + longitude + ", latitude=" + latitude
				+ ", inside=" + inside + ", provider=" + provider + "]";
	}
	
}